/*
 * This file is part of the MDR library.
 * Copyright (C) 2023 Mateusz Viste
 */

#include <mdr/bios.h>

/* returns the current BIOS tick counter (18.2 Hz, 1 tick is roughly 55ms, an
 * hour has 65543 ticks). works on IBM PC, XT, AT - ie. it's always safe */
unsigned short mdr_bios_ticks(void) {
  unsigned short ticks = 0;
  _asm {
    xor ah, ah /* int 1Ah, ah=0: Read System Clock, PC/XT/AT compatible */
    int 0x1A   /* number of clock ticks since midnight is returned in CX:DX */
    mov ticks, dx /* save lower 16bits of ticks into ticks */
  }
  return(ticks);
}
