/*
 * This file is part of the MDR library.
 * Copyright (C) 2013-2023 Mateusz Viste
 */

#include <mdr\bios.h>

/* waits for ticks time (1 tick is roughly 55ms, an hour has 65543 ticks)
 * works on IBM PC, XT, AT - ie. it's always safe */
void mdr_bios_tickswait(unsigned short ticks) {
  _asm {
    xor ah, ah /* int 1Ah, ah=0: Read System Clock, PC/XT/AT compatible */
    int 0x1A   /* number of clock ticks since midnight is returned in CX:DX */
    mov bx, dx /* save ticks value in BX */
    add bx, ticks
    POLL:
    int 0x1A
    cmp dx, bx
    jne POLL /* repeat until target value is not reached */
  }
}
