#include <stdio.h>
#include <string.h>

#include <mdr\unzip.h>

int main(int argc, char **argv) {
  FILE *fd;
  struct mdr_zip_item z;
  const char *file_to_extract = NULL;

  if ((argc < 2) || (argc > 3)) {
    puts("usage: ziplist file.zip [file_to_extract]");
    return(1);
  }

  if (argc == 3) {
    file_to_extract = argv[2];
  }

  fd = fopen(argv[1], "rb");
  if (fd == NULL) {
    printf("failed to open file '%s'\n", argv[1]);
    return(1);
  }

  bzero(&z, sizeof(z));
  for (;;) {
    int res = mdr_zip_iter(&z, fd);

    if ((res < 0) || (res > 1)) {
      printf("ERROR %d\n", res);
      break;
    }
    if (res == 1) {
      puts("<end of archive>");
      break;
    }

    printf("%13s  %lu bytes compressed to %lu, CRC %08lX, off %lu\n", z.fname, z.filelen, z.compressedfilelen, z.crc32, z.dataoffset);

    if ((file_to_extract != NULL) && (strcmp(file_to_extract, z.fname) == 0)) {
      FILE *fde;
      unsigned long i;
      printf("file %s found, extracting...\n", file_to_extract);
      fde = fopen(file_to_extract, "wb");
      fseek(fd, z.dataoffset, SEEK_SET);
      for (i = 0; i < z.compressedfilelen; i++) {
        unsigned char b = getc(fd);
        fputc(b, fde);
      }
      fclose(fde);
    }
  }

  fclose(fd);

  return(0);
}
